Attribute VB_Name = "modIni"
Option Explicit

Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
Private Declare Function GetPrivateProfileSection Lib "kernel32" Alias "GetPrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long

Public Function sReadIni(sKey As String, sSection As String) As String
Dim Result As String * 128
    Let sReadIni$ = Left$(Result, GetPrivateProfileString(sSection, sKey, "", Result, Len(Result), Trim(App.Path & "\" & App.EXEName & ".ini")))
End Function

Public Sub sWriteIni(sKey As String, sSection As String, ByVal sValue As String)
    Call WritePrivateProfileString(sSection, sKey, sValue, Trim(App.Path & "\" & App.EXEName & ".ini"))
End Sub

Public Sub DeleteIniKey(ByVal sKey As String, ByVal sSection As String)
'sub to delete a particular key inside an ini section.
   Call WritePrivateProfileString(sSection, sKey, 0&, Trim(App.Path & "\" & App.EXEName & ".ini"))
End Sub

Public Sub DeleteOldKeys(ByVal strSection As String, listBox As listBox)
Dim strKeyAndVal() As String
Dim strBuffer As String
Dim intX As Integer
Dim i As Integer
Dim strDeleteKey As String
Dim bExists As Boolean
    Let strBuffer$ = String$(750, Chr$(0&))
    Call GetPrivateProfileSection(strSection, strBuffer, Len(strBuffer), Trim(App.Path & "\" & App.EXEName & ".ini"))
    strKeyAndVal = Split(strBuffer, vbNullChar)
    For intX = LBound(strKeyAndVal) To UBound(strKeyAndVal)
        If strKeyAndVal(intX) = vbNullString Then Exit For
        'check if the key exists in the listbox. If not, remove it!
        strDeleteKey = Left(strKeyAndVal(intX), InStr(strKeyAndVal(intX), "=") - 1)
        bExists = False
        For i = 0 To listBox.ListCount
            'bExists = False
            If listBox.List(i) = Left(strKeyAndVal(intX), InStr(strKeyAndVal(intX), "=") - 1) Then
                bExists = True
            End If
        Next i
        If Not bExists Then
            DeleteIniKey strDeleteKey, strSection
        End If
    Next
    Erase strKeyAndVal
End Sub

Public Sub GetSectionKeyToList(ByVal strSection As String, listBox As listBox)
'function to get the key count of a particular ini section.
Dim strKeyAndVal() As String
Dim strBuffer As String
Dim intX As Integer

    Let strBuffer$ = String$(750, Chr$(0&))
    Call GetPrivateProfileSection(strSection, strBuffer, Len(strBuffer), Trim(App.Path & "\" & App.EXEName & ".ini"))
    strKeyAndVal = Split(strBuffer, vbNullChar)
    For intX = LBound(strKeyAndVal) To UBound(strKeyAndVal)
        If strKeyAndVal(intX) = vbNullString Then Exit For
        listBox.AddItem Left(strKeyAndVal(intX), InStr(strKeyAndVal(intX), "=") - 1)
    Next
    Erase strKeyAndVal
End Sub


